function r=bisect(f,a,b,tol)
  % Root of a function

    
  fa=feval(f,a);
  fb=feval(f,b);
  if ((fa*fb)> 0)
    disp('No roots here!');
    return;
  end

  if (fa == 0) 
    r=a;
    return
  end
  
  if (fb == 0) 
    r=b;
    return
  end
  t1=max(abs(tol),eps);
  r=inner_bisect(f,a,fa,b,fb,t1); 

end

function r=inner_bisect(f,a,fa,b,fb,tol)
  

  mx = a+(b-a)/2;
  if (abs(b-a) < (tol)*(max(abs(a),abs(b))))
    r=mx;
    return
  end

  my=feval(f,mx); 
  if (my==0) 
    r=mx;
    return
  end

  if ((fa*my)<0) 
    r=inner_bisect(f,a,fa,mx,my,tol);
  else
    r=inner_bisect(f,mx,my,b,fb,tol);
  end
end
  